
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C23BB2  ; location in v1.0 or v1.1
;org $C23B9A  ; location in SFC version
C23BB2:	JSR clear_everything

org $C23BCD  ; location in v1.0 or v1.1
;org $C23BB5  ; location in SFC version
C23BCD:	JSR clear_everything

org $C2439D  ; location in v1.0 or v1.1
;org $C24385  ; location in SFC version
C2439D:	JSR prep_statuses

org $C243FC  ; location in v1.0 or v1.1
;org $C243E4  ; location in SFC version
C243FC:	JSR clear_everything

org $C244D1  ; location in v1.0 or v1.1
;org $C244B9  ; location in SFC version
DW spell_set,spell_clear,spell_toggle

spell_set:
C244D7:	LDA $11AA  ; status bytes 1 & 2 set by spell...
C244DA:	STA $FC
C244DC:	LDA $F8
C244DE:	TRB $FC  ; ...minus what we already have
C244E0:	LDA $11AC  ; status bytes 3 & 4 set by spell...
C244E3:	STA $FE
C244E5:	LDA $FA
C244E7:	TRB $FE  ; ...minus what we already have
C244E9:	RTS

spell_toggle:  ; comment out this label if reversing
	JSR spell_set

spell_clear:
C244ED:	LDA $11AA  ; status bytes 1 & 2 removed by spell...
C244F0:	AND $F8  ; ...minus what we don't have
C244F2:	STA $F4
C244F4:	LDA $11AC  ; status bytes 3 & 4 removed by spell...
C244F7:	AND $FA  ; ...minus what we don't have
C244F9:	STA $F6
C244FB:	RTS

;REMOVED1:
;spell_toggle:
;	JSR spell_set
;	JMP spell_clear

clear_everything:
C244FC:	TDC
C244FD:	STA $3DD4,Y
C24500:	STA $3DE8,Y
C24503:	STA $3DFC,Y
C24506:	STA $3E10,Y
C24509:	RTS

	NOP
	NOP

prep_statuses:
C2450C:	LDA $3DFC,Y  ; *
C2450F:	STA $F4  ; statuses to lose, page 1 *
C24511:	LDA $3E10,Y  ; *
C24514:	STA $F6  ; statuses to lose, page 2 *
C24516:	LDA $3DD4,Y  ; statuses to add, page 1
C24519:	AND $331C,Y  ; minus immunities
C2451C:	STA $FC
C2451E:	LDA $3DE8,Y  ; statuses to add, page 2
C24521:	AND $3330,Y  ; minus immunities
C24524:	STA $FE
C24526:	LDA $3EE4,Y  ; current status, page 1
C24529:	STA $F8
;REMOVED2:
;	AND #$0040
;	TSB $FC
C2452B:	LDA $3EF8,Y  ; current status, page 2
C2452E:	STA $FA
C24530:	LDA $3C1C,Y  ; max HP
C24533:	LSR A
C24534:	LSR A
C24535:	LSR A  ; max HP / 8
C24536:	CMP $3BF4,Y  ; current HP
C24539:	LDA #$0200
;REMOVED3:
;	BIT $F8
;	BNE check_carry_set
REPLACE1:
C2453C:	BCC clear_near_fatal  ; if current HP <= max HP / 8...
;C2453C:	BCC no_near_fatal
C2453E:	TSB $FC  ; ...set Near Fatal

check_carry_set:
C24540:	BCS no_near_fatal  ; otherwise...

clear_near_fatal:
C24542:	TSB $F4  ; ...clear Near Fatal

no_near_fatal:
	LDA $F8
	AND #$0040  ; are we currently Petrified?
	BEQ overcast  ; if so, clear a bunch of statuses
	JSR $460E  ; v1.0 or v1.1
;	JSR $45F6  ; SFC only
overcast:

; if Assassin's "1-way status immunity fix" patch is applied, comment out
; the two NOPs above and everything between them and here, except the four
; instructions marked by asterisks, and uncomment everything that follows

;C24514:	LDA $3EF8,Y
;C24517:	STA $FA  ; current status, page 2
;	LDA $3DE8,Y  ; statuses to add, page 2
;	AND $3330,Y  ; minus immunities
;	STA $FE
;C24521:	LDA $331C,Y
;C24524:	PHA  ; save immunities
;C24525:	AND $3DD4,Y
;C24528:	STA $FC  ; statuses to add minus immunities, page 1
;C2452A:	XBA
;C2452B:	ROL A  ; Carry set if Wound is being added
;C2452C:	TDC
;C2452D:	ROL A
;C2452E:	ROL A  ; move Wound bit into position
;C2452F:	AND $3E4D,Y  ; is Overcast bit set?
;C24532:	AND $01,S  ; are we susceptible to Zombie?
;C24534:	TSB $FC  ; if both are true, mark Zombie to be set...
;C24536:	XBA
;C24537:	LSR A
;C24538:	LSR A
;C24539:	TRB $FC  ; ...remove Wound from statuses to add...
;C2453B:	ASL A
;C2453C:	TSB $F4  ; ...and mark Condemned to be removed
;C2453E:	LDA $3EE4,Y
;C24541:	STA $F8  ; current status, page 1
;REMOVED4:  ; two instructions
;	AND #$0040
;	TSB $FC
;C24543:	LDA $3C1C,Y  ; max HP
;C24546:	LSR A
;C24547:	LSR A
;C24548:	LSR A  ; max HP / 8
;C24549:	CMP $3BF4,Y  ; current HP
;C2454C:	LDA #$0200
;REMOVED5:  ; two instructions
;	BIT $F8
;	BNE check_carry_set
;REPLACE2:
;C2454F:	BCC clear_near_fatal  ; this...
;C2454F:	BCC no_near_fatal  ; ...is replacing this
;C24551:	TSB $FC
;check_carry_set:
;C24553:	BCS no_near_fatal
;clear_near_fatal:
;C24555:	TSB $F4
;no_near_fatal:
;	LDA $F8
;	AND #$0040
;	BEQ pull
;	JSR $460E  ; v1.0 or v1.1
;	JSR $45F6  ; SFC only
;pull:
;C24561:	PLA  ; restore blocked statuses
;C24562:	AND $FC  ; remove them from statuses to add
;C24564:	STA $FC
;C24566:	PHA
;REMOVED6:  ; two instructions
;	LDA $3DE8,Y
;	AND $3330,Y
;REPLACE3:
;C24567:	LDA $FE  ; this...
;C24567:	STA $FE  ; ...replaces this